package lt.bit.SauktiniuSarasas.aspect;

import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.time.LocalDateTime;
import java.util.List;

import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.AfterReturning;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Component;

import lt.bit.SauktiniuSarasas.entities.Sauktinis;
import lt.bit.SauktiniuSarasas.services.SauktiniaiService;



@Aspect
@Component
public class SendNotificationEmail {
	
	@Autowired
	SauktiniaiService sauktiniaiService;
	
	@Before("execution(* lt.bit.SauktiniuSarasas.restControllers.SauktiniaiController.add(..))")
	public void beforeSauktinisGetById(JoinPoint jp) throws IOException {
		String name=( (Sauktinis) jp.getArgs()[0] ).getName();
		Authentication a=SecurityContextHolder.getContext().getAuthentication();
		
		
		LocalDateTime now=LocalDateTime.now();
		
		
		FileWriter fileWriter=new FileWriter("c:/log/log.txt", true);
		PrintWriter pw=new PrintWriter(fileWriter);
		pw.println("["+now.toString()+"] "+a.getName()+" pridejo nauja sauktini - "+name);
		pw.close();
	}
	
	
	
	@Before("execution(* deleteSauktinis(..))")
	public void beforeSauktinisDelete(JoinPoint jp) throws IOException{
		
		Integer id=(Integer)jp.getArgs()[0];
		String name=sauktiniaiService.getSauktinis(id).getName();
		
		Authentication a=SecurityContextHolder.getContext().getAuthentication();
		
		LocalDateTime now=LocalDateTime.now();
		
		FileWriter fileWriter=new FileWriter("c:/log/log.txt", true);
		PrintWriter pw=new PrintWriter(fileWriter);
		pw.println("["+now.toString()+"] "+a.getName()+" ištrynė sauktinį - "+name);
		pw.close();
	}
	
	
	@Before("execution(* saveSauktinis(..))")
	public void beforeNewSauktinisCorrectPhone(JoinPoint jp) {
		Sauktinis s=(Sauktinis)jp.getArgs()[0];
		s.setPhone("+370"+s.getPhone());
	}
	
	@AfterReturning(pointcut = "execution(* getSauktiniai())", returning = "result")
	public void afterHideSurnames(List<Sauktinis> result) {
		Authentication a=SecurityContextHolder.getContext().getAuthentication();
		if (! a.getName().equals("gediminas")) {
			for(Sauktinis s:result) {
				s.setSurname("***");
			}
		}
	}
	
	
	
	

}
