package lt.bit.SauktiniuSarasas.restControllers;

import java.security.Principal;
import java.util.Base64;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PatchMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.method.annotation.MethodArgumentTypeMismatchException;
import org.springframework.web.server.ResponseStatusException;

import lt.bit.SauktiniuSarasas.Exeptions.ErrorResponse;
import lt.bit.SauktiniuSarasas.Exeptions.SauktinisException;
import lt.bit.SauktiniuSarasas.entities.Sauktinis;
import lt.bit.SauktiniuSarasas.services.SauktiniaiService;

import com.fasterxml.jackson.core.JacksonException;
import com.fasterxml.jackson.databind.exc.InvalidFormatException;

@RestController
@RequestMapping("/sauktiniai")
public class SauktiniaiController {
	@Autowired
	SauktiniaiService sauktiniaiService;
	

	/*
	@ExceptionHandler(value = {JacksonException.class})
	public ResponseEntity<ErrorResponse> invalidData() {
		System.out.println("Klaida pagauta");
		return new ResponseEntity<>(new ErrorResponse("Invalid input", "", 400), HttpStatus.BAD_REQUEST);
	}
	
	@ExceptionHandler(value= {SauktinisException.class})
	public ResponseEntity<ErrorResponse> sauktinisException(SauktinisException e){
		return new ResponseEntity<>(new ErrorResponse(e.getMessage(),"",e.getCode()), HttpStatus.valueOf(e.getCode()));
	}
	@ExceptionHandler(value= {Exception.class})
	public ResponseEntity<ErrorResponse> defaultException(Exception e){
		return new ResponseEntity<>(new ErrorResponse("Unknown error ","",500), HttpStatus.INTERNAL_SERVER_ERROR);
	}
	*/
	
	
	@CrossOrigin
	@GetMapping("/")
	public List<Sauktinis> index() /* throws InterruptedException */{
		//Thread.sleep(1000+(int)(Math.random()*3000));
		return sauktiniaiService.getSauktiniai();
	}
	
	@CrossOrigin
	@PostMapping("/")
	public Sauktinis add(@RequestBody Sauktinis s ){
		Sauktinis se=sauktiniaiService.getByEmail(s.getEmail());
		if (se==null) {
			return sauktiniaiService.saveSauktinis(s);
		}
		throw new SauktinisException("Šauktinis su nurodytu el. paštu egzistuoja", 400);
	}
	
	@CrossOrigin
	@GetMapping("/{id}")
	public Sauktinis get(@PathVariable Integer id) {
		Sauktinis s=sauktiniaiService.getSauktinis(id);
		if (s==null) {
			 throw new SauktinisException("Šauktinis su nurodytu ID nerastas",404);
		}
		return s;
	}
	
	@CrossOrigin
	@PatchMapping("/{id}")
	public Sauktinis update(@PathVariable Integer id, @RequestBody Sauktinis s) {
		if (s.getAge()<18) {
			throw new SauktinisException("Šauktinio amžius yra per mažas",400);
		}
		
		Sauktinis se=sauktiniaiService.getByEmail(s.getEmail());
		if (se==null || se.getId()==s.getId()) {
			return sauktiniaiService.updateSauktinis(s);
		}
		
		throw new SauktinisException("Šauktinis su nurodytu el. paštu egzistuoja", 400);
	}
	
	@CrossOrigin
	@DeleteMapping("/{id}")
	public Boolean delete(@PathVariable Integer id) {
		 sauktiniaiService.deleteSauktinis(id);
		 return true;
	}
	
	@CrossOrigin
	@GetMapping("/email/{email}")
	public Boolean newEmail(@PathVariable String email) {
		  return (sauktiniaiService.getByEmail(email)==null);
	}
	
	@CrossOrigin
	@GetMapping("/{id}/email/{email}")
	public Boolean updateEmail(@PathVariable Integer id, @PathVariable String email ) {
		  Sauktinis s= sauktiniaiService.getByEmail(email);
		  if (s!=null) {
			  if (s.getId()==id) {
				  return true;
			  }else {
				  return false;
			  }
		  }else {
			  return true;
		  }
	}
	
	
	
}
